package com.bonus.canteen.core.menu.vo;

import cn.hutool.core.util.NumberUtil;
import cn.hutool.core.util.ObjectUtil;
import com.bonus.canteen.core.common.utils.SysUtil;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.Optional;

@ApiModel("菜品列表")
public class MenuEleDishRowRecipeDetailVO implements Serializable {
   @ApiModelProperty("餐品id")
   private Long mealId;
   @ApiModelProperty("餐品名称")
   private String mealName;
   @ApiModelProperty("餐品类型")
   private Integer mealType;
   @ApiModelProperty("菜品质量(g/份)")
   private BigDecimal weight;
   @ApiModelProperty("图片")
   private String imageUrl;
   @ApiModelProperty("销售价格")
   private Integer salePrice;
   @ApiModelProperty("热量(千卡/100g)")
   private BigDecimal calories;
   @ApiModelProperty("蛋白质(g/100g)")
   private BigDecimal protein;
   @ApiModelProperty("脂肪(g/100g)")
   private BigDecimal fat;
   @ApiModelProperty("碳水化合物(g/100g)")
   private BigDecimal carbohydrate;
   @ApiModelProperty("膳食纤维(g/100g)")
   private BigDecimal dietaryFiber;
   @ApiModelProperty("胆固醇(mg/100g)")
   private BigDecimal cholesterol;
   @ApiModelProperty("钙(mg/100g)")
   private BigDecimal calcium;
   @ApiModelProperty("钠(mg/100g)")
   private BigDecimal sodium;
   @ApiModelProperty("热量NRV(千卡/100g)")
   private BigDecimal caloriesNrv;
   @ApiModelProperty("蛋白质NRV(g/100g)")
   private BigDecimal proteinNrv;
   @ApiModelProperty("脂肪NRV(g/100g)")
   private BigDecimal fatNrv;
   @ApiModelProperty("碳水化合物NRV(g/100g)")
   private BigDecimal carbohydrateNrv;
   @ApiModelProperty("膳食纤维NRV(g/100g)")
   private BigDecimal dietaryFiberNrv;
   @ApiModelProperty("胆固醇NRV(mg/100g)")
   private BigDecimal cholesterolNrv;
   @ApiModelProperty("钙NRV(mg/100g)")
   private BigDecimal calciumNrv;
   @ApiModelProperty("钠NRV(mg/100g)")
   private BigDecimal sodiumNrv;

   public BigDecimal getCaloriesNrv() {
      return !ObjectUtil.isNull(this.weight) && !NumberUtil.equals(this.weight, BigDecimal.ZERO) ? ((BigDecimal)Optional.ofNullable(this.calories).orElse(BigDecimal.ZERO)).divide(this.weight, 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP).multiply(new BigDecimal("4.185")).divide(new BigDecimal("8400"), 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP) : BigDecimal.ZERO;
   }

   public BigDecimal getProteinNrv() {
      return !ObjectUtil.isNull(this.weight) && !NumberUtil.equals(this.weight, BigDecimal.ZERO) ? ((BigDecimal)Optional.ofNullable(this.protein).orElse(BigDecimal.ZERO)).divide(this.weight, 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP).divide(new BigDecimal("60"), 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP) : BigDecimal.ZERO;
   }

   public BigDecimal getFatNrv() {
      return !ObjectUtil.isNull(this.weight) && !NumberUtil.equals(this.weight, BigDecimal.ZERO) ? ((BigDecimal)Optional.ofNullable(this.fat).orElse(BigDecimal.ZERO)).divide(this.weight, 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP).divide(new BigDecimal("60"), 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP) : BigDecimal.ZERO;
   }

   public BigDecimal getCarbohydrateNrv() {
      return !ObjectUtil.isNull(this.weight) && !NumberUtil.equals(this.weight, BigDecimal.ZERO) ? ((BigDecimal)Optional.ofNullable(this.carbohydrate).orElse(BigDecimal.ZERO)).divide(this.weight, 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP).divide(new BigDecimal("300"), 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP) : BigDecimal.ZERO;
   }

   public BigDecimal getDietaryFiberNrv() {
      return !ObjectUtil.isNull(this.weight) && !NumberUtil.equals(this.weight, BigDecimal.ZERO) ? ((BigDecimal)Optional.ofNullable(this.dietaryFiber).orElse(BigDecimal.ZERO)).divide(this.weight, 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP).divide(new BigDecimal("25"), 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP) : BigDecimal.ZERO;
   }

   public BigDecimal getCholesterolNrv() {
      return !ObjectUtil.isNull(this.weight) && !NumberUtil.equals(this.weight, BigDecimal.ZERO) ? ((BigDecimal)Optional.ofNullable(this.cholesterol).orElse(BigDecimal.ZERO)).divide(this.weight, 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP).divide(new BigDecimal("300"), 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP) : BigDecimal.ZERO;
   }

   public BigDecimal getCalciumNrv() {
      return !ObjectUtil.isNull(this.weight) && !NumberUtil.equals(this.weight, BigDecimal.ZERO) ? ((BigDecimal)Optional.ofNullable(this.calcium).orElse(BigDecimal.ZERO)).divide(this.weight, 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP).divide(new BigDecimal("800"), 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP) : BigDecimal.ZERO;
   }

   public BigDecimal getSodiumNrv() {
      return !ObjectUtil.isNull(this.weight) && !NumberUtil.equals(this.weight, BigDecimal.ZERO) ? ((BigDecimal)Optional.ofNullable(this.sodium).orElse(BigDecimal.ZERO)).divide(this.weight, 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP).divide(new BigDecimal("2000"), 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP) : BigDecimal.ZERO;
   }

   public String getImageUrl() {
      return SysUtil.getCutFileUrl(this.imageUrl);
   }

   public Long getMealId() {
      return this.mealId;
   }

   public String getMealName() {
      return this.mealName;
   }

   public Integer getMealType() {
      return this.mealType;
   }

   public BigDecimal getWeight() {
      return this.weight;
   }

   public Integer getSalePrice() {
      return this.salePrice;
   }

   public BigDecimal getCalories() {
      return this.calories;
   }

   public BigDecimal getProtein() {
      return this.protein;
   }

   public BigDecimal getFat() {
      return this.fat;
   }

   public BigDecimal getCarbohydrate() {
      return this.carbohydrate;
   }

   public BigDecimal getDietaryFiber() {
      return this.dietaryFiber;
   }

   public BigDecimal getCholesterol() {
      return this.cholesterol;
   }

   public BigDecimal getCalcium() {
      return this.calcium;
   }

   public BigDecimal getSodium() {
      return this.sodium;
   }

   public void setMealId(final Long mealId) {
      this.mealId = mealId;
   }

   public void setMealName(final String mealName) {
      this.mealName = mealName;
   }

   public void setMealType(final Integer mealType) {
      this.mealType = mealType;
   }

   public void setWeight(final BigDecimal weight) {
      this.weight = weight;
   }

   public void setImageUrl(final String imageUrl) {
      this.imageUrl = imageUrl;
   }

   public void setSalePrice(final Integer salePrice) {
      this.salePrice = salePrice;
   }

   public void setCalories(final BigDecimal calories) {
      this.calories = calories;
   }

   public void setProtein(final BigDecimal protein) {
      this.protein = protein;
   }

   public void setFat(final BigDecimal fat) {
      this.fat = fat;
   }

   public void setCarbohydrate(final BigDecimal carbohydrate) {
      this.carbohydrate = carbohydrate;
   }

   public void setDietaryFiber(final BigDecimal dietaryFiber) {
      this.dietaryFiber = dietaryFiber;
   }

   public void setCholesterol(final BigDecimal cholesterol) {
      this.cholesterol = cholesterol;
   }

   public void setCalcium(final BigDecimal calcium) {
      this.calcium = calcium;
   }

   public void setSodium(final BigDecimal sodium) {
      this.sodium = sodium;
   }

   public void setCaloriesNrv(final BigDecimal caloriesNrv) {
      this.caloriesNrv = caloriesNrv;
   }

   public void setProteinNrv(final BigDecimal proteinNrv) {
      this.proteinNrv = proteinNrv;
   }

   public void setFatNrv(final BigDecimal fatNrv) {
      this.fatNrv = fatNrv;
   }

   public void setCarbohydrateNrv(final BigDecimal carbohydrateNrv) {
      this.carbohydrateNrv = carbohydrateNrv;
   }

   public void setDietaryFiberNrv(final BigDecimal dietaryFiberNrv) {
      this.dietaryFiberNrv = dietaryFiberNrv;
   }

   public void setCholesterolNrv(final BigDecimal cholesterolNrv) {
      this.cholesterolNrv = cholesterolNrv;
   }

   public void setCalciumNrv(final BigDecimal calciumNrv) {
      this.calciumNrv = calciumNrv;
   }

   public void setSodiumNrv(final BigDecimal sodiumNrv) {
      this.sodiumNrv = sodiumNrv;
   }
}
